#include <genesis.h>
#include "resource.h"
// 1.ϐєz
#define MAX_BLOCKS 10
#define MAX_POWER 75
Sprite sprites[MAX_BLOCKS+2];
int g_block_x[MAX_BLOCKS+2];
int g_block_y[MAX_BLOCKS+2];
int g_block_use[MAX_BLOCKS+2];
char height_str[32],power_str[32];
u16 value,ind;
int x,y,power,jump,pleft,pright;
int i,count,height,downflag;

// 2.ubN֐
void create_block(int bx,int by,int num){
	SPR_initSprite(&sprites[num],&block_sprite,
		bx,by, 
		TILE_ATTR(PAL0, TRUE, FALSE, FALSE));
	SPR_update(sprites, num+1);
	g_block_x[num] = bx; // XW
	g_block_y[num] = by; // YW
	g_block_use[num] = 1; // ubNgptOON
}

// 3.Q[I[o[
void gameover(){
	VDP_drawText("GAME OVER",16,13);
	while(1){
		value = JOY_readJoypad(0);
		if(value) break; // L[Eo
		VDP_waitVSync();
	}
	VDP_drawText("         ",16,13);
}

// 4.Q[JnȌ
void stage_init(){
	// ϐ
	x=156; y=40; power=0; jump=0; pleft=1; pright=1;
	i=0; count=0; height=40; downflag=0;
	// XvCg
	SPR_init(256);
	SPR_initSprite(&sprites[0],&hako_sprite,x,y, 
		TILE_ATTR(PAL0, TRUE, FALSE, FALSE));
	VDP_setPalette(0,hako_sprite.palette->data);
	// ubN
	for(i=0;i<=MAX_BLOCKS;i++){
		g_block_x[i]=0; g_block_y[i]=-32; g_block_use[i]=0;
	}
	// @̐^ɃubNzu
	create_block(x-12,y+8,1);
	JOY_init();
}


// C[`
int main(){
// BG`
	ind = TILE_USERINDEX;
	VDP_setPaletteColors(0, palette_black, 64);
	VDP_drawImageEx(BPLAN,&bg1,
					TILE_ATTR_FULL(PAL0,TRUE, FALSE, FALSE, ind),
					0,0,
					FALSE,TRUE);
    ind += bg1.tileset->numTile;
    VDP_setPalette(0,bg1.palette->data);
// eLXg
	strcpy(height_str,"Height :  ");
	strcpy(power_str ,"Power  :  ");

// Xe[W֐s
	stage_init();

// C[v
	while(1){
		// 5.Eړpbh
		value = JOY_readJoypad(0);
		if(value & BUTTON_LEFT){
			x=x-1-(pleft/16); pleft++;
		}else{
			pleft=1;
		}
		if(value & BUTTON_RIGHT){
			x=x+1+(pright/16);pright++;
		}else{
			pright=1;
		}
		// 6.ubN
		downflag=0;
		for(i=1;i<=MAX_BLOCKS-1;i++){
			if(g_block_use[i]==1){
				// @Ă邩ih~j
				if(x+8>g_block_x[i] && x<g_block_x[i]+32 &&
				 y+8>g_block_y[i] && y<g_block_y[i]+8){
				 	 downflag=1;
					// ubNɏĂꍇWvł
					if(!(value & BUTTON_A) && power!=0){
						jump = power; power=0;
						// őp[ŔԂƃubN
						if(jump==MAX_POWER){
								jump+=25; // ő厞MAX+25Ƀu[Xg
								SND_startPlay_VGM(se_crash);
								SPR_initSprite(&sprites[i],&broken_sprite,
								g_block_x[i],g_block_y[i], 
								TILE_ATTR(PAL0, TRUE, FALSE, FALSE));
								g_block_use[i]=2;
						}else{ // ʏp[̌ʉ
							SND_startPlay_VGM(se_jump);
						}
					}
				}
			}
			// ubNƔj󂳂ꂽubN̗Əs
			if(g_block_use[i]!=0){
				// ubN3t[Ɉx
				if(count%3==0) g_block_y[i]++;
				// ubN̏s
				if(g_block_y[i]>224){
					g_block_y[i]=-8; g_block_use[i]=0;
				}
			}
		}
		// @͏ĂȂƗ
		if(downflag==0){ y++; height--; }
		// ubNƈꏏɎR(ubNƂ̌Ԃ𖄂߂邽)
		if(count%3==0) y++;
		// ԂA{^Ń`[W
		if(downflag==1 && (value & BUTTON_A)){
			power++;
			if(power>MAX_POWER) power=MAX_POWER;
		}

		// 7.Wv
		if(jump>0){
			y = y - (jump/5); jump=jump-5;
			height+=(jump/5);
		}
		if(height<0) height=0;

		// 8.ubN𐶐(120t[Ɉx)
		if(count%120==0){
			for(i=1;i<=MAX_BLOCKS-1;i++){
				if(g_block_use[i]==0){
					create_block(random()%288,0,i);
					break;
				}
			}
		}
		// XvCgĕ`
		SPR_setPosition(&sprites[0],x,y);
		for(i=1;i<=MAX_BLOCKS-1;i++){
			if(g_block_use[i]!=0){
				SPR_setPosition(&sprites[i],g_block_x[i],g_block_y[i]);
			}
		}
		SPR_update(sprites,MAX_BLOCKS);

		// 9.xƃ`[Wl\
		intToStr(height,height_str+9,8); VDP_drawText(height_str,0,0);
		intToStr(power,power_str+9,3); VDP_drawText(power_str,0,1);

		count++;
		// 10.ʊOɗƃQ[I[o[
		if(y>224){
			SPR_init(256); gameover();
			stage_init();
		}
		VDP_waitVSync();
	}
	return 0;
}
